
; ===============================================================================
;			
;    -- EditBox_HeapAlloc.asm --
;			Jay Sullivan
;
;
;	Description:  This program calls HeapAlloc
;				to allocate a block of memory for
;				an edit box.
; ===============================================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     includes
	;----------------------------
		
		include EditBox_HeapAlloc.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
		WndProc PROTO hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetProcessHeap
		mov hHeap, eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX,
	  msg:MSG,
	  hwnd:HWND


		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset szClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
			
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------		
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, Offset szClassName, Offset szAppName,\
				WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\
				CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
				NULL,NULL,hInst,NULL
			mov hwnd,eax			
			
		;-----------------------------
		;	Show Window
		;-----------------------------		
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd		
				
		;-----------------------------
		;	Message Loop
		;-----------------------------		
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	;-----------------------------
	 .if uMsg==WM_CREATE
	;-----------------------------
		
		
		
		;================================================
		;	Warning box with parent set to hWnd.
		;
		;  Doesn't affect the rest of the program.
		;================================================
		
			invoke MessageBox,hWnd,Offset szWarningMBText,Offset szWarningMBCaption,MB_OK
		
		
		;------------------------------------------------
		;	Allocate memory
		;------------------------------------------------
		
			invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY, 4096
			mov hHeapAlloc, eax
			
		;================================================
		;
		;	Write '1234'.   It appears correctly
		;
		;================================================
		
			mov dword ptr [eax], '4321'
			
		;------------------------------------------------
		;	Assert that HeapAlloc worked.
		;------------------------------------------------
			.if eax==0
				invoke MessageBox,hWnd,Offset szErrorMBText,Offset szErrorMBCaption,MB_OK
				invoke PostQuitMessage, NULL
				xor eax,eax
				ret
			.endif
		;------------------------------------------------
		;	hEditBox Create
		;------------------------------------------------
		
			invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCEdit, 0, WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT or ES_MULTILINE or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_WANTRETURN or WS_VSCROLL or WS_HSCROLL or DS_LOCALEDIT,0,0,355,335,hWnd,0,hInstance,0
			mov hEditBox,eax
	
		;------------------------------------------------
		;	Link the edit box to the HeapAllocated section.
		;------------------------------------------------
		
			invoke SendMessage,hEditBox,EM_SETHANDLE,hHeapAlloc,0
			
		;------------------------------------------------
		;	Set the maximum text to one page. (Well, 4095 bytes.)
		;------------------------------------------------
		
			invoke SendMessage,hEditBox,EM_SETLIMITTEXT,4095,0
			
			
			
	;-----------------------------
	 .elseif uMsg==WM_DESTROY
	;-----------------------------
		
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .elseif uMsg==WM_SIZE
	;-----------------------------
	
		movzx eax, word ptr lParam   ; << width
		movzx ecx, word ptr lParam+2 ; << height
		invoke MoveWindow,hEditBox, 0,0, eax, ecx, TRUE
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP




End Start